Index: admin/langimport.php
===================================================================
RCS file: /cvsroot/moodle/moodle/admin/langimport.php,v
retrieving revision 1.24
diff -u -r1.24 langimport.php
--- admin/langimport.php	28 Nov 2006 19:25:24 -0000	1.24
+++ admin/langimport.php	29 Nov 2006 10:50:49 -0000
@@ -244,19 +244,16 @@
             }
             
             print_simple_box_start('center','60%');
-            echo '<table width="100%"><tr><td align="center">';
-            echo '<label for="uninstalllang">'.get_string('installedlangs','admin').'</label>';
-            echo '</td><td align="center">';
-            echo '<label for="pack">'.get_string('availablelangs','admin').'</label>';
-            echo '</td></tr>';
+            echo '<table summary="" width="100%">';
             echo '<tr><td align="center" valign="top">';
-            echo '<form name="uninstallform" action="langimport.php?mode=4" method="POST">';
+            echo '<form name="uninstallform" action="langimport.php?mode=4" method="post">';
             echo '<input name="sesskey" type="hidden" value="'.sesskey().'" />';
             unset($CFG->langlist);   // ignore admin's langlist
             $installedlangs = get_list_of_languages();
 
             /// display installed langs here
 
+            echo '<label for="uninstalllang">'.get_string('installedlangs','admin')."</label><br />\n";
             echo '<select name="uninstalllang" id="uninstalllang" size="15">';
             foreach ($installedlangs as $clang =>$ilang){
                 echo '<option value="'.$clang.'">'.$ilang.'</option>';
@@ -264,10 +261,9 @@
             echo '</select>';
             echo '<br /><input type="submit" value="'.get_string('uninstall','admin').'" />';
             echo '</form>';
-            echo '<form name="updateform" action="langimport.php?mode=5" method="POST">';
+            echo '<form name="updateform" action="langimport.php?mode=5" method="post">';
             echo '<br /><input type="submit" value="'.get_string('updatelangs','admin').'" />';
             echo '</form>';
-            echo '<p />';
             
             /// Display option to change site language
  
@@ -275,7 +271,7 @@
             
 //            print_string('changesitelang','admin');
 //            $sitelanguage = get_record('config','name','lang');
-//            echo '<form name="changelangform" action="langimport.php?mode=3" method="POST">';
+//            echo '<form name="changelangform" action="langimport.php?mode=3" method="post">';
 //            echo '<select name="sitelangconfig">';
 //            
 //            foreach ($installedlangs as $clang =>$ilang) {
@@ -293,13 +289,14 @@
             /// display to be installed langs here
 
             echo '</td><td align="center" valign="top">';
-            echo '<table><tr><td valign="top" align="center">';    //availabe langs table
+            //availabe langs table
             $empty = 1;    //something to pring
 
             /// if this language pack is not already installed, then we allow installation
 
-            echo '<form name="installform" method="POST" action="langimport.php?mode=2">';
+            echo '<form name="installform" method="post" action="langimport.php?mode=2">';
             echo '<input name="sesskey" type="hidden" value="'.sesskey().'" />';
+            echo '<label for="pack">'.get_string('availablelangs','admin')."</label><br />\n";
             if ($remote) {
                 echo '<select name="pack" id="pack" size="15">';
             }
@@ -323,18 +320,16 @@
             }
             if ($remote) {
                 echo '</select>';
-                echo '<br/ ><input type="submit" value="<-- '.get_string('install','admin').'">';
+                echo '<br /><input type="submit" value="&larr; '.get_string('install','admin').'" />';
             }
             echo '</form>';
 
             if ($empty) {
-                echo '<tr><td align="center">';
+                echo '<br />';
                 print_string('nolanguagetodownload','admin');
-                echo '</td></tr>';
             }
 
-            echo '</td><tr></table>';    //close available langs table
-            echo '<form>';
+            //close available langs table
             echo '</td></tr></table>';
             print_simple_box_end();
 